library(stringr)
library(ggplot2)
library(gridExtra)
library(lubridate)
library(dplyr)
library(mgcv) #gam
######################################################################################
death_cert<-read.csv("/datos/THESIS: Hurricane Maria/Mortality Data P.R/death_cert.csv")
death_cert$X <- NULL ### Eliminar columna

DATOS <- data.frame(year=death_cert$year, month=death_cert$month, day=death_cert$day,   date=as.character(death_cert$date), 
                    pop1=death_cert$pop, rate1=death_cert$rate, pop2=death_cert$pop2, rate2=death_cert$rate2, deaths=death_cert$deaths,
                    sepsis=death_cert$Sepsis, diabetes=death_cert$Diabetes, alzhaparki=death_cert$AlzheParki, neumonia=death_cert$Pneumo, 
                    cancer=death_cert$cancer, respiratorio=death_cert$respira, corazon=death_cert$corazon, cerebro=death_cert$cerebro,  
                    suicidio=death_cert$suici, caida=death_cert$caida, transp=death_cert$trans, homicidio=death_cert$homici, a_otros=death_cert$others)

death_new<-apply(DATOS[,10:22], 1, as.vector)  ### Realizar suma acumalada por dias
g<-data.frame(death_new)
####### convertir g en un vector
x=NULL
y=NULL
for (i in 1:1826) {
  x= c(y, g[,i] )
  y = x
}
####################################################################################  
DATOS<-DATOS[rep(seq_len(nrow(DATOS)), each=13),] ##### Cada celda de death_cert_new se multiplica por las 13 Enfermedades 
dim(DATOS)  ##23738  22

Enfermedades<-c("sepsis","diabetes","alzhaparki","neumonia","cancer","respiratorio","corazon","cerebro","suicidio","caida","transp","homicidio","a_otros")
causa<-as.factor(rep(Enfermedades,1826))
DATOS <- data.frame(DATOS,causa)

####################################################################################
DATOS$deaths=y
################## Generar la matriz de ceros y unos
t<-rbind(rep(diag(1,13,13),1826))
enf<-matrix(t,23738,13,byrow = TRUE)
DATOS[,10:22]=enf    #### reemplazar la matriz de cero y unos denntro del data.frame
###################################################################################
dn<-1:nrow(DATOS) #index of time
msep<-ifelse(DATOS$year==2017 & DATOS$month==9 & DATOS$day>=20,1,0) #after maria september indicator, not sum(ms)=11 as it should
moct<-ifelse(DATOS$year==2017 & DATOS$month==10,1,0)
mnov<-ifelse(DATOS$year==2017 & DATOS$month==11,1,0)
mdic<-ifelse(DATOS$year==2017 & DATOS$month==12,1,0)
mene<-ifelse(DATOS$year==2018 & DATOS$month==1,1,0)
mfeb<-ifelse(DATOS$year==2018 & DATOS$month==2,1,0)
mmar<-ifelse(DATOS$year==2018 & DATOS$month==3,1,0)
##################################################################################
lpop1<-log(DATOS$pop1)
lpop2<-log(DATOS$pop2)
#Time<-(dn - min(dn))/(max(dn) - min(dn))
doy1<-c(rep(1:365, each = 13),rep(1:365, each = 13),rep(1:366, each = 13),rep(1:365, each = 13),rep(1:365, each = 13))
#################################################################
##### Modelo ensayo 1::: family=quasipoisson
yr1<-as.factor(DATOS$year)
fit_model2<- gam(deaths ~ s(doy1,k=8,bs="cc") + (msep + moct + mnov + mdic + mene + mfeb + mmar)*causa 
                 + yr1, offset=lpop1, family=quasipoisson, method="REML", data=DATOS)

out2 <- summary(fit_model2)
exp(out2$p.coeff[2:105]-1.96*out2$se[2:105])
exp(out2$p.coeff[2:105]+1.96*out2$se[2:105])
exp(coef(fit_model2)[2:20])

plot(fit_model1,all.terms=T)